<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="80px">
      <el-form-item label="方案GUID" prop="sinsGuid">
        <el-input v-model="queryParams.sinsGuid" placeholder="请输入方案GUID" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="明细名称" prop="scheName">
        <el-input v-model="queryParams.scheName" placeholder="请输入明细名称" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['sins:sinssche:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate" v-hasPermi="['sins:sinssche:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete" v-hasPermi="['sins:sinssche:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['sins:sinssche:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns" storageKey="sins-sinssche-index"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="dataList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="明细名称" align="center" prop="scheName" />
      <el-table-column label="检查内容" align="center" prop="scheCont" />
      <el-table-column label="操作" align="center" width="200">
        <template #default="scope">
          <el-tooltip content="修改" placement="top">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['sins:sinssche:edit']"></el-button>
          </el-tooltip>
          <el-tooltip content="删除" placement="top">
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['sins:sinssche:remove']"></el-button>
          </el-tooltip>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />

    <el-dialog :title="title" v-model="open" width="650px" append-to-body>
      <el-form ref="formRef" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="方案GUID" prop="sinsGuid">
          <el-input v-model="form.sinsGuid" placeholder="请输入方案GUID" />
        </el-form-item>
        <el-form-item label="明细名称" prop="scheName">
          <el-input v-model="form.scheName" placeholder="请输入明细名称" />
        </el-form-item>
        <el-form-item label="检查内容" prop="scheCont">
          <el-input v-model="form.scheCont" type="textarea" placeholder="请输入检查内容" />
        </el-form-item>
        <el-form-item label="开始时间" prop="scheStartTime">
          <el-date-picker v-model="form.scheStartTime" type="datetime" placeholder="选择开始时间" />
        </el-form-item>
        <el-form-item label="完成时间" prop="scheCompTime">
          <el-date-picker v-model="form.scheCompTime" type="datetime" placeholder="选择完成时间" />
        </el-form-item>
        <el-form-item label="编制时间" prop="scheMakeTime">
          <el-date-picker v-model="form.scheMakeTime" type="datetime" placeholder="选择编制时间" />
        </el-form-item>
        <el-form-item label="是否完成" prop="scheIsComp">
          <el-input v-model="form.scheIsComp" placeholder="请输入是否完成" />
        </el-form-item>
        <el-form-item label="编制人GUID" prop="scheMakeGuid">
          <el-input v-model="form.scheMakeGuid" placeholder="请输入编制人GUID" />
        </el-form-item>
        <el-form-item label="备注" prop="note">
          <el-input v-model="form.note" type="textarea" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="SinsSche">
import { listBisSinsSche, getBisSinsSche, addBisSinsSche, updateBisSinsSche, delBisSinsSche } from "@/api/slaj/sins";
import { getCurrentInstance, reactive, ref, toRefs } from "vue";

const { proxy } = getCurrentInstance();

const dataList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const columns = ref({
  scheName: { label: "明细名称", visible: true },
  scheCont: { label: "检查内容", visible: true }
});

const data = reactive({
  form: {},
  queryParams: { pageNum: 1, pageSize: 10, sinsGuid: null, scheName: null },
  rules: {}
});
const { form, queryParams, rules } = toRefs(data);

function getList() {
  loading.value = true;
  listBisSinsSche(queryParams.value).then(response => {
    dataList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.guid);
  single.value = selection.length !== 1;
  multiple.value = !selection.length;
}

function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加检查方案明细";
}

function handleUpdate(row) {
  reset();
  getBisSinsSche(row.guid || ids.value[0]).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改检查方案明细";
  });
}

function submitForm() {
  proxy.$refs["formRef"].validate(valid => {
    if (valid) {
      if (form.value.guid != null) {
        updateBisSinsSche(form.value).then(() => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addBisSinsSche(form.value).then(() => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

function handleDelete(row) {
  proxy.$modal.confirm('是否确认删除？').then(function() {
    return delBisSinsSche(row.guid || ids.value.join(","));
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  });
}

function handleExport() {
  proxy.download('/sins/sinssche/export', { ...queryParams.value }, `检查方案明细_${new Date().getTime()}.xlsx`);
}

function cancel() {
  open.value = false;
  reset();
}

function reset() {
  form.value = { sinsGuid: null, scheName: null, scheCont: null, scheStartTime: null, scheCompTime: null, scheMakeTime: null, scheIsComp: null, scheMakeGuid: null, note: null };
  proxy.resetForm("formRef");
}

getList();
</script>
